var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { encodeHtml, setAttributes } from './utils';
import { AdapterOptionsProvider } from './adapter-options-provider';
import { loadCss } from '@cnblogs/load-script-css';
import { HljsEngineClassToken, PrismjsEngineToken } from './constants';
/**
 * @public
 */
var BaseHighlighter = /** @class */ (function () {
    function BaseHighlighter() {
        this._isDarkTheme = false;
        this.removeLinkElements('link[rel=stylesheet][prismjs]');
        this.removeLinkElements('link[rel=stylesheet][hljs]');
    }
    Object.defineProperty(BaseHighlighter.prototype, "enableCodeLineNumber", {
        get: function () {
            return false;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseHighlighter.prototype, "adapterOptions", {
        get: function () {
            return AdapterOptionsProvider.get();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseHighlighter.prototype, "isDarkTheme", {
        get: function () {
            return this._isDarkTheme;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseHighlighter.prototype, "linesHighlightedClassToken", {
        get: function () {
            return this.id + '-lines-highlighted';
        },
        enumerable: false,
        configurable: true
    });
    BaseHighlighter.prototype.highlightAllUnder = function (parentEl, beforeHighlightBlock, afterHighlightBlock) {
        return __awaiter(this, void 0, void 0, function () {
            var el, codeBlocks, highlightTasks, _loop_1, _i, codeBlocks_1, codeBlock;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof parentEl === 'string') {
                            el = document.querySelector(parentEl);
                        }
                        else {
                            el = parentEl;
                        }
                        if (!el)
                            return [2 /*return*/];
                        codeBlocks = Array.from(el.querySelectorAll('pre code')).map(function (el) { return el; });
                        if (!(codeBlocks.length > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.ensureResourcesLoaded()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        highlightTasks = [];
                        _loop_1 = function (codeBlock) {
                            var preEl = codeBlock.parentElement;
                            var codeEl = codeBlock;
                            if (beforeHighlightBlock && !beforeHighlightBlock(preEl, codeEl)) {
                                return "continue";
                            }
                            highlightTasks.push(new Promise(function (resolve, reject) {
                                _this.highlight(codeEl).then(function () {
                                    if (afterHighlightBlock) {
                                        afterHighlightBlock(preEl, codeEl);
                                    }
                                    resolve();
                                }, function () { return reject(); });
                            }));
                        };
                        for (_i = 0, codeBlocks_1 = codeBlocks; _i < codeBlocks_1.length; _i++) {
                            codeBlock = codeBlocks_1[_i];
                            _loop_1(codeBlock);
                        }
                        return [4 /*yield*/, Promise.all(highlightTasks)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BaseHighlighter.prototype.setTheme = function (theme, attributes, isDarkTheme) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var tagId, themeLoaded;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.setIsDarkTheme(isDarkTheme);
                        if (!theme && !this.highlighterOptions.defaultTheme) {
                            throw Error('Theme is required! And default theme not configured!');
                        }
                        if (!theme)
                            theme = this.highlighterOptions.defaultTheme;
                        tagId = "highlighter-theme-".concat(theme);
                        themeLoaded = false;
                        (_a = document.querySelectorAll('link[id*=highlighter-theme-],link[id*=line-numbers-style]')) === null || _a === void 0 ? void 0 : _a.forEach(function (e) {
                            if (e.id === tagId) {
                                themeLoaded = true;
                                return;
                            }
                            e.remove();
                        });
                        if (themeLoaded)
                            return [2 /*return*/];
                        this._themeHref = "".concat(this.highlighterOptions.themeBaseUrl, "/").concat(theme, ".css");
                        return [4 /*yield*/, loadCss({
                                href: this._themeHref,
                                id: tagId,
                                beforeElementCreateCallback: function (el) { return setAttributes(el, attributes); },
                            })];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BaseHighlighter.prototype.resolveContainerElements = function (el) {
        var preEl = null;
        var codeEl = null;
        if (el instanceof HTMLPreElement) {
            preEl = el;
            codeEl = el.querySelector('code');
        }
        else if (el.tagName.toLowerCase() === 'code' && el.parentElement instanceof HTMLPreElement) {
            preEl = el.parentElement;
            codeEl = el;
        }
        if (!codeEl || !preEl) {
            return;
        }
        return [preEl, codeEl];
    };
    BaseHighlighter.prototype.loadStyles = function (attributes) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var styles, tasks, _i, styles_1, style;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        styles = (_a = this.highlighterOptions.stylesheets) !== null && _a !== void 0 ? _a : [];
                        tasks = [];
                        for (_i = 0, styles_1 = styles; _i < styles_1.length; _i++) {
                            style = styles_1[_i];
                            tasks.push(loadCss({
                                href: style.href,
                                id: style.tagId,
                                beforeElementCreateCallback: function (el) { return setAttributes(el, attributes); },
                            }));
                        }
                        return [4 /*yield*/, Promise.all(tasks)];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BaseHighlighter.prototype.tryApplyLang = function (el) {
        var _a, _b, _c, _d, _e, _f;
        if (!el)
            return '';
        var classes = Array.from(el.classList);
        var parentElementTagName = (_c = (_b = (_a = el.parentElement) === null || _a === void 0 ? void 0 : _a.tagName) === null || _b === void 0 ? void 0 : _b.toLowerCase()) !== null && _c !== void 0 ? _c : '';
        if (classes.findIndex(function (x) { return x.startsWith('language-'); }) < 0 && parentElementTagName === 'pre') {
            var preClasses = Array.from((_e = (_d = el.parentElement) === null || _d === void 0 ? void 0 : _d.classList) !== null && _e !== void 0 ? _e : []);
            var lang = preClasses.find(function (x) { return x.startsWith('language-'); });
            if (lang) {
                el.classList.add(lang);
            }
        }
        return (_f = Array.from(el.classList).find(function (x) { return x.startsWith('language-'); })) !== null && _f !== void 0 ? _f : '';
    };
    BaseHighlighter.prototype.setBodyClass = function (engine) {
        var classes = ['prismjs-engine', 'hljs-engine'];
        var classList = window.document.body.classList;
        classList.remove.apply(classList, classes);
        switch (engine) {
            case 'prismjs':
                classList.add(classes[0]);
                break;
            case 'highlight.js':
                classList.add(classes[1]);
                break;
        }
    };
    BaseHighlighter.prototype.setEngineClassToken = function (engine, preEl) {
        var classes = [PrismjsEngineToken, HljsEngineClassToken];
        var codeEl = preEl.querySelector('code');
        var classLists = [codeEl === null || codeEl === void 0 ? void 0 : codeEl.classList, preEl.classList];
        for (var _i = 0, classLists_1 = classLists; _i < classLists_1.length; _i++) {
            var list = classLists_1[_i];
            list === null || list === void 0 ? void 0 : list.remove.apply(list, classes);
            switch (engine) {
                case 'prismjs':
                    list === null || list === void 0 ? void 0 : list.add(classes[0]);
                    break;
                case 'highlight.js':
                    list === null || list === void 0 ? void 0 : list.add(classes[1]);
                    break;
            }
        }
    };
    BaseHighlighter.prototype.removeLinesHighlightedClassToken = function () {
        var els = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            els[_i] = arguments[_i];
        }
        for (var _a = 0, els_1 = els; _a < els_1.length; _a++) {
            var el = els_1[_a];
            var classList = el.classList;
            classList.remove.apply(classList, Array.from(classList).filter(function (x) { return x.endsWith('-lines-highlighted'); }));
        }
    };
    /**
     * 过滤code元素中的内容, e.g. 移除行号元素, html标签等
     * @param el
     */
    BaseHighlighter.prototype.filterCodeContent = function (el) {
        var _a, _b;
        if (!el)
            return '';
        // details下的code元素的innerText属性可能会返回空值, 所以创建一个临时的code元素来处理
        // textContent会忽略<br>元素导致不换行
        // https://gitlab.cnblogs.com/dev/BlogServer/-/issues/3461
        // https://gitlab.cnblogs.com/dev/BlogServer/-/issues/3448
        var codeEl = document.createElement('code');
        codeEl.style.opacity = '0';
        codeEl.style.width = '0';
        codeEl.style.height = '0';
        codeEl.style.whiteSpace = 'pre';
        if (el.tagName.toLowerCase() === 'code') {
            codeEl.innerHTML = el.innerHTML;
        }
        else if (el.tagName.toLowerCase() === 'pre' && el.querySelector('code')) {
            codeEl.innerHTML = (_b = (_a = el.querySelector('code')) === null || _a === void 0 ? void 0 : _a.innerHTML) !== null && _b !== void 0 ? _b : '';
        }
        else {
            return '';
        }
        // remove line numbers generated by prismjs
        var lineNumberRowsEl = codeEl.querySelector('.line-numbers-rows');
        if (lineNumberRowsEl) {
            lineNumberRowsEl.remove();
        }
        // remove line numbers generated by hljs
        var hljsLineNumbersEl = codeEl.querySelectorAll('.hljs-ln-line.hljs-ln-numbers');
        hljsLineNumbersEl === null || hljsLineNumbersEl === void 0 ? void 0 : hljsLineNumbersEl.forEach(function (x) { return x.remove(); });
        document.body.append(codeEl);
        var innerText = codeEl.innerText;
        codeEl.remove();
        el.innerHTML = encodeHtml(innerText);
        return innerText;
    };
    BaseHighlighter.prototype.removeLinkElements = function (selector) {
        var _a;
        (_a = document.querySelectorAll(selector)) === null || _a === void 0 ? void 0 : _a.forEach(function (x) { return x.remove(); });
    };
    BaseHighlighter.prototype.resolveLinesToHighlight = function (el) {
        var attr = el.getAttribute('data-lines-highlight');
        try {
            var parsed = JSON.parse(attr !== null && attr !== void 0 ? attr : '[]');
            return Array.isArray(parsed) ? parsed.map(function (lineNumber) { return lineNumber - 1; }) : [];
        }
        catch (ex) {
            console.warn(ex);
            return undefined;
        }
    };
    BaseHighlighter.prototype.setIsDarkTheme = function (value) {
        this._isDarkTheme = value !== null && value !== void 0 ? value : false;
    };
    return BaseHighlighter;
}());
export { BaseHighlighter };
