"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CnblogsPresetAdapterOptions = exports.DefaultAdapterOptions = void 0;
/**
 * @public
 */
exports.DefaultAdapterOptions = {
    enableCodeLineNumber: true,
    prism: {
        scriptPath: '/prism.min.js',
        autoLoaderPluginPath: '',
        lineNumberPluginPath: '',
        stylesheets: [],
        themeBaseUrl: '',
        defaultTheme: '',
    },
    hljs: {
        scriptPath: '/highlight.min.js',
        lineNumberPluginPath: '/highlightjs-line-numbers.min.js',
        stylesheets: [],
        themeBaseUrl: '',
        defaultTheme: '',
    },
};
/**
 * @public
 */
exports.CnblogsPresetAdapterOptions = {
    enableCodeLineNumber: false,
    prism: {
        scriptPath: 'https://common.cnblogs.com/prism/prism.js?v=1.23.0',
        lineNumberPluginPath: 'https://common.cnblogs.com/prism/plugins/line-numbers/prism-line-numbers.min.js',
        autoLoaderPluginPath: 'https://common.cnblogs.com/prism/plugins/autoloader/prism-autoloader.min.js',
        lineNumberStylePath: 'https://common.cnblogs.com/prism/plugins/line-numbers/prism-line-numbers.css',
        themeBaseUrl: 'https://www.cnblogs.com/css/prismjs',
        defaultTheme: 'prism-vs',
        stylesheets: [],
    },
    hljs: {
        scriptPath: 'https://common.cnblogs.com/highlight/11.4.0/highlight.min.js',
        lineNumberPluginPath: 'https://common.cnblogs.com/scripts/highlightjs-line-numbers.min.js',
        stylesheets: [],
        themeBaseUrl: 'https://www.cnblogs.com/css/hljs',
        defaultTheme: 'cnblogs',
    },
};
