"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HighlightersFactory = void 0;
var highlighter_option_1 = require("./highlighter-option");
var hljs_highlighter_1 = require("./hljs-highlighter");
var prism_highlighter_1 = require("./prism-highlighter");
var adapter_options_provider_1 = require("./adapter-options-provider");
/**
 * @public
 */
var HighlightersFactory = /** @class */ (function () {
    function HighlightersFactory() {
    }
    HighlightersFactory.configCodeHighlightOptions = function (options) {
        adapter_options_provider_1.AdapterOptionsProvider.set(options);
    };
    HighlightersFactory.useCnblogsCodeHighlightOptions = function () {
        this.configCodeHighlightOptions(highlighter_option_1.CnblogsPresetAdapterOptions);
    };
    HighlightersFactory.createCodeHighlighter = function (engine, theme, options) {
        if (options)
            this.configCodeHighlightOptions(options);
        var highlighter;
        switch (engine) {
            case 'highlight.js':
                highlighter = new hljs_highlighter_1.HljsHighlighter();
                break;
            case 'prismjs':
                highlighter = new prism_highlighter_1.PrismHighlighter();
                break;
            default:
                throw Error('unknown highlight engine');
        }
        if (!theme)
            theme = highlighter.highlighterOptions.defaultTheme;
        var themeName = typeof theme === 'string' ? theme : theme.name;
        var isDark = typeof theme === 'string' ? false : theme.isDark;
        highlighter.setTheme(themeName, undefined, isDark).then();
        return highlighter;
    };
    return HighlightersFactory;
}());
exports.HighlightersFactory = HighlightersFactory;
