"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HljsLanguagesLoader = void 0;
var load_script_css_1 = require("@cnblogs/load-script-css");
var languagesMap = {
    tcltk: 'tcl',
    tclsh: 'tcl',
    tk: 'tcl',
    pq: 'powerquery',
    mscript: 'powerquery',
    M: 'powerquery',
    wat: 'wasm',
    wast: 'wasm',
    webassembly: 'wasm',
};
var HljsLanguagesLoader;
(function (HljsLanguagesLoader) {
    var _this = this;
    var registerAlias = function (language) {
        var aliases = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            aliases[_i - 1] = arguments[_i];
        }
        var hljsLanguage = hljs.getLanguage(language);
        if (hljsLanguage) {
            hljs.registerAliases(aliases.filter(function (x) { return hljs.getLanguage(x) == null; }), { languageName: language });
            return true;
        }
        else {
            console.warn("Try to register [".concat(aliases.join(','), "] as aliases of ").concat(language, ", but ").concat(language, " is not defined."));
            return false;
        }
    };
    HljsLanguagesLoader.load = function (lang, options) { return __awaiter(_this, void 0, void 0, function () {
        var mappedLang, scriptPath, splits, url, err_1;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    lang = lang.toLowerCase().trim().replace('language-', '');
                    mappedLang = (_a = languagesMap[lang]) !== null && _a !== void 0 ? _a : lang;
                    if (!mappedLang || hljs.getLanguage(mappedLang)) {
                        registerAlias(mappedLang, lang);
                        return [2 /*return*/];
                    }
                    scriptPath = options.scriptPath;
                    splits = scriptPath.split('/');
                    splits.pop();
                    url = splits.join('/') + "/languages/".concat(mappedLang, ".min.js");
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, (0, load_script_css_1.loadScript)({
                            id: "hljs-language-".concat(mappedLang),
                            src: url,
                        })];
                case 2:
                    _b.sent();
                    registerAlias(mappedLang, lang);
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _b.sent();
                    console.warn('加载hljs语言定义脚本失败', err_1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); };
})(HljsLanguagesLoader || (HljsLanguagesLoader = {}));
exports.HljsLanguagesLoader = HljsLanguagesLoader;
